Timer for Bonelab speedruns.

The timer will appear and start when loading into Descent, pauses during loading screens and finishes when sitting in the taxi. Also has an option to time individual levels (see configuration section below).

# Installation

- Make sure [Melon Loader](https://melonwiki.xyz/#/?id=what-is-melonloader) version 0.5.7 or newer is installed in Bonelab
  - To install Melon Loader for Quest follow the [instructions here](https://github.com/LemonLoader/MelonLoader/wiki/Installation)
- Download [the mod from Thunderstore](https://bonelab.thunderstore.io/package/jakzo/SpeedrunTimer/) (click on "Manual Download")
- Open the downloaded `.zip` file and extract `Mods/SpeedrunTimer.dll` into `BONELAB/Mods/SpeedrunTimer.dll` which is usually at:
  - Steam: `C:\Program Files (x86)\Steam\steamapps\common\BONELAB\BONELAB`
  - Oculus: `C:\Program Files\Oculus\Software\Software\stress-level-zero-inc-bonelab`
  - Quest: `/sdcard/Android/data/com.StressLevelZero.BONELAB/files`

## Livesplit Integration

Because no Livesplit autosplitter exists for the game yet and it's hard to create one, there is an autosplitter which is controlled by this mod. For the autosplitter to work, this mod must be installed and running. To set up the autosplitter:

- Download the [BonelabSpeedrunTimer.asl](https://raw.githubusercontent.com/jakzo/SlzSpeedrunTools/main/projects/Bonelab/SpeedrunTimer/scripts/BonelabSpeedrunTimer.asl) autosplitter (right click on [this link](https://raw.githubusercontent.com/jakzo/SlzSpeedrunTools/main/projects/Bonelab/SpeedrunTimer/scripts/BonelabSpeedrunTimer.asl) -> save link)
- Start Livesplit and edit layout settings (right click -> edit layout)
- Click the `+` icon and select "control" -> "scriptable auto splitter"
- Click the "layout settings" button then select the "scriptable auto splitter" tab
- Click the "browse" button and select the BonelabSpeedrunTimer.asl file you downloaded
- If it worked you should see some options appear

By default the autosplitter will pause during loading screens, split every time the level changes (not on level reload) or when sitting in the taxi and reset when exiting the taxi or changing levels after sitting in the taxi. Create your splits accordingly.

If you've set up the autosplitter you may not want the in-game timer anymore. You can disable it by setting the `hide` option to `true` (see instructions below).

### Quest

This mod also works with Livesplit One and Quest. See the instructions at [http://vr.jf.id.au/](http://vr.jf.id.au/input-viewer/instructions.html) to set it up.

## Input Viewer

This mod also supports an input viewer for showing your controller inputs and headset position to be used as an overlay for gameplay recordings. You can find instructions to install the input viewer at [http://vr.jf.id.au/](http://vr.jf.id.au/).

# Configuration

You can change some settings by editing the file at `BONELAB/MelonLoader/MelonPreferences.cfg` or by using MelonPreferencesManager:

- Install [MelonPreferencesManager](https://github.com/sinai-dev/MelonPreferencesManager) (download the IL2CPP version)
- Open the menu in-game using F5 to change config options

Most settings require restarting the level to take effect.

# Links

- Source code: https://github.com/jakzo/SlzSpeedrunTools/tree/main/projects/Bonelab/SpeedrunTimer
- Thunderstore: https://bonelab.thunderstore.io/package/jakzo/SpeedrunTimer/

# Changelog

## 1.6.0

Added a display to level leaderboards to show the time you got, even if you didn't beat your best time for the level.

## 1.5.0

Added Livesplit One websocket support.

## 1.4.0

Added input viewer.

## 1.3.0

Accidental release, no changes. 😅

## 1.2.0

A few quality of life updates, particularly for Quest:

- Splits view to show the individual level times of the current run during loading screens
- On Quest deleting all game data from the main menu no longer deletes your mods (so you don't need to use a PC to add the SpeedrunTimer after each run)
- Tweaked styling of loading screen text to make it more readable
- Deleted the IL option since you can use the splits view now

## 1.1.1

Fixed timer not stopping when sitting in the Taxi for latest patch.

## 1.1.0

Added individual level mode. Also lists active mods during load screens instead of disabling the timer if any disallowed mods are active.

## 1.0.3

Added instructions for Quest.

## 1.0.2

Fix to show time greater than one hour instead of resetting to zero.

## 1.0.1

Fix time not showing in loading screens and timer starting too early before loading finishes.

## 1.0.0

Make it work for new game patch.

## 0.1.2

Fixed link to autosplitter in readme.

## 0.1.1

Fix anticheat, allow load mirror mod and improve Livesplit integration.

## 0.1.0

Livesplit autosplitter integration.

## 0.0.2

Fix bug on Steam version not allowing references to Scene type.

## 0.0.1

Initial release. Timer appears on wrist and in loading screens. Automatically starts in Descent, pauses on load and ends when sitting in the taxi.

